# 命令字：.call
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能：**用于执行指定的函数或方法，并在调试会话中查看和分析结果。
**基本用法：**：**.call [选项] 方法名 [参数列表]**
其中，**方法名**是要执行的函数或方法的名称，可以是全局符号、模块符号或内核函数。**参数列表**是要传递给函数或方法的参数。

**.call**命令支持以下选项：

**-a**: 用于指定对调用的函数进行内联展开，将其嵌入到**.call**命令中。这样可以更方便地执行一些简单的函数，而不必在调试会话中定义函数。
**-r**: 用于指定执行完函数后，将结果返回到内联展开的调用点。


## 用法描述
使用**.call**命令可以方便地执行自定义的或系统提供的函数，以观察其行为并观察结果。这对于调试和分析特定代码路径或验证某些条件时非常有用。
## 用例
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_0ccd8a0c7ad5b2f5623cf6fbc328a72a_r.png)
这将在调试会话中执行**moduleName**模块中的**FunctionName**函数，并传递**arg1**和**arg2**作为参数。你可以查看执行过程中的输出或观察函数对调试会话的影响。

注意，**.call**命令在调试过程中执行代码时可能会有一定的风险，请确保你了解代码的行为和潜在影响，以及如何处理可能的异常情况。