# 命令字 .event_code
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能:** **event_code**是指调试事件的代码值。调试事件是特定的事件或条件，例如异常、断点命中或线程创建等，可以由调试器捕获和处理。**event_code**可以帮助我们识别和理解不同的调试事件，以便更好地分析和解决问题。
**基本用法：**：**event_code**

## 用例

1. **EXCEPTION_EVENT (0x00000001)**: 异常事件。当应用程序或操作系统遇到异常情况（如访问冲突、除以零等）时，调试器将捕获此事件。

2. **CREATE_THREAD_EVENT (0x00000002)**: 线程创建事件。当新线程被创建时，调试器将捕获此事件。

3. **CREATE_PROCESS_EVENT (0x00000004)**: 进程创建事件。当新进程被创建时，调试器将捕获此事件。

4. **EXIT_THREAD_EVENT (0x00000008)**: 线程退出事件。当线程结束时，调试器将捕获此事件。

5. **EXIT_PROCESS_EVENT (0x00000010)**: 进程退出事件。当进程结束时，调试器将捕获此事件。

6. **LOAD_MODULE_EVENT (0x00000020)**: 模块加载事件。当一个动态链接库或可执行文件被加载时，调试器将捕获此事件。

7. **UNLOAD_MODULE_EVENT (0x00000040)**: 模块卸载事件。当一个动态链接库或可执行文件被卸载时，调试器将捕获此事件。

8. **OUTPUT_DEBUG_STRING_EVENT (0x00000080)**: 调试输出事件。当应用程序通过**OutputDebugString**函数输出调试信息时，调试器将捕获此事件。

这只是一小部分**event_code**，**NDB**支持的调试事件众多，每个事件都有特定的**event_code**。通过了解和理解不同的**event_code**，我们可以更好地利用**NDB**进行调试和错误分析。