# 命令字 .kframes
**基本功能：**用于显示当前的调用栈信息。
**基本用法：** **.kframes**



## 示例
在**NDB**中，执行**".kframes"**命令会输出类似下面的信息：

```
Child-SP          RetAddr           Call Site
00000000`0151ee28 00007ff7`90290246 ntdll_7ff7f90200c7
00000000`0151ee30 00007ff7`9028ff18 ntdll_7ff7f90200c3
00000000`0151ee40 00007ff7`9028fed4 ntdll_7ff7f9022346
00000000`0151eeb0 00007ff7`9028cfee ntdll_7ff7f902374f
00000000`0151ef10 00007ff7`901df4e3 ntdll_7ff7f88008c9
00000000`0151ef60 00007ff7`9010ccf9 ntdll_7ff7f47d15b3
00000000`0151efd0 00007ff7`9010ccc5 ntdll_7ff7f47d82fe
00000000`0151f000 00007ff7`9010cc91 ntdll_7ff7f47d79c9
...
```

## 用法描述
当调试一个应用程序时，调用栈**（call stack）**是一个很重要的概念。它是一个记录了当前程序执行到某个位置前，经过的函数调用关系的堆栈结构。每当一个函数被调用时，它的返回地址就会被压入调用栈中，而在调用完成后，返回地址又会被弹出。

使用**".kframes"**命令可以查看当前调用栈的信息。它会显示当前执行点上的函数调用链，以及每个调用的相关信息，如函数名、参数值、返回地址等。通过查看调用栈，我们可以了解程序的执行流程、找出导致错误的函数调用路径，以及定位到特定函数的问题所在。

在这个示例中，我们可以看到调用栈中的多个帧**（frame）**信息，每个帧代表一个函数调用。其中包含了子栈指针**（Child-SP）**、返回地址**（RetAddr）**和函数调用的位置**（Call Site）**等信息。

通过分析和跟踪调用栈，在程序发生错误或异常时，我们可以找出问题的根源，帮助开发人员定位和修复**bug**。**".kframes"**命令在**NDB**中的使用也是非常常见的调试技术之一。