# 命令字 .lines
**基本功能：**用于调试过程中显示或隐藏源代码行号。
**基本用法：** **.lines [on|off]**

执行**.lines**命令后，可以根据参数的值来控制源代码行号的显示。以下是对参数的解释：

**on**: 表示开启源代码行号显示，调试输出中将包含源代码的行号信息。
**off**: 表示关闭源代码行号显示，调试输出中将不显示源代码的行号信息。


## 用法描述
在调试过程中，默认情况下，**NDB**会显示源代码的行号信息，以帮助开发人员定位问题所在。但在某些情况下，显示源代码行号可能会导致调试输出过于繁杂，不方便观察其他调试信息。使用**".lines"**命令可以灵活地控制是否显示源代码行号。

例如，执行**.lines on**可以打开源代码行号的显示，而执行**.lines off**可以关闭源代码行号的显示。

这个命令对于根据需要在调试过程中动态调整调试输出的详细程度和可读性非常有用。通过控制源代码行号的显示，开发人员可以更好地集中精力观察其他关键的调试信息，或者在需要查看源代码时轻松地打开行号显示以进行调试和分析。

除了**".lines"**命令外，**NDB**还提供了其他命令来控制和改进调试过程的可视化展示，如**".srcpath"**用于设置源代码文件的搜索路径，**".sympath"**用于设置符号文件的搜索路径等。这些命令可以帮助开发人员根据实际需求调整调试环境，提高调试效率。