# 命令字.load
**基本功能：**用于加载指定的调试扩展或插件。
**基本用法：** **.load <扩展名称> [<参数>]**

其中，扩展名称是要加载的调试扩展的名称或文件路径。参数是可选的，可以根据需要传递给加载的扩展。
## 示例
例如，可以使用 **".load"** 命令加载 **SOS** 扩展，该扩展在调试 **.NET** 应用程序时非常有用。命令如下所示：

```
.load sos
```

有些调试扩展可能需要特定的符号文件或其他资源文件。在加载扩展之前，确保已正确配置符号路径和相关资源，以便调试器能够找到所需的文件。

此外，一些调试扩展可能具有不同的版本，可以通过指定文件路径加载特定版本的扩展。例如，使用绝对路径加载扩展的命令如下所示：

```
.load C:\path\to\myExtension.dll
```

加载扩展后，调试器就可以使用扩展提供的命令和功能来辅助调试过程。不同的调试器扩展提供了各种各样的功能，例如查看特定数据结构、执行特定的分析任务或生成自定义报告等。

请注意，在加载扩展时，确保扩展的来源可信，并遵循安全实践，以防止恶意代码的执行。

除了 **".load"** 命令外，**NDB** 还提供其他命令和选项来管理调试扩展，例如 **".unload"** 命令用于卸载已加载的扩展，**".chain"** 命令用于显示已加载的扩展链表等。这些命令和选项可以帮助开发人员灵活地配置和使用调试扩展，以满足不同的调试需求。