# 命令字：ba
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能**：用于在调试器中设置访问断点。访问断点是一种特殊类型的断点，当程序试图读取或写入特定内存地址时，会触发断点并暂停程序的执行。
**基本用法**：
1. 设置读访问断点：**ba r[p|w] Address**
   在指定的 **Address** 处设置读访问断点，此断点将在程序尝试读取该内存地址时暂停程序执行。
   **r** 表示读取访问。
   **p** 表示断点是针对进程级别的。
   **w** 表示断点是针对线程级别的。
2. 设置写访问断点：**ba w[p|w] Address**
   在指定的**Address**处设置写访问断点，此断点将在程序尝试写入该内存地址时暂停程序执行。

3. 删除断点：**bd BreakpointID**
   删除指定**BreakpointID**的断点。可以使用 **bl** 命令查看断点的标识符。
   
## 示例
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_270ee5445e263d20875250a4f3bf6ca3_r.png)
## 用法描述
请注意，访问断点是强大的调试工具，但在设置过多的情况下可能会引起性能问题。因此，请谨慎使用并确保只设置必要的断点。
# 命令字：bp
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能**：用于在指定的代码地址设置断点，当程序执行到该断点时，会暂停程序的执行并返回到调试器中。
**基本用法**：**bp [Address]**
## 示例
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_400edd42704f7de80f72f88940c0c2c3_r.png)
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_d9dc68c4c7ccf754def8155b42669a3a_r.png)

# 命令字：bu
**基本功能**：用于设置一个临时的非执行断点，即在指定的代码地址处设置一个断点，但不会暂停程序的执行。相反，它会将该断点转换为一条反汇编指令，并在程序执行到该指令时显示相关信息，然后继续执行。
**基本用法**：**bu [Address]**
## 示例
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_e9c1759843e99879ec654ed5755e1739_r.png)
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_dcb90264d9499468ebae95a37941802f_r.png)

# 命令字：bm
**基本功能**：用于在指定的模块加载时设置断点。当指定的模块被加载到进程中时，程序会暂停执行，并在调试器中返回到断点所在位置。
**基本用法**：**bm [ModuleName]**
## 用法描述
这些命令可以帮助我们控制程序的执行，并在需要时暂停执行以便进行调试。使用断点可以让我们观察程序的状态，检查变量和数据，并跟踪代码的执行流程。在调试和分析过程中，这些命令是非常有用的工具。

请注意，使用这些命令时要谨慎，并确保在适当的位置设置断点，以避免影响程序的正常执行。