# 1.命令字：g
**基本功能**：用于继续执行程序，让其正常执行。如果提供了表达式参数，程序将会在满足该表达式为真的条件下停止执行。如果没有提供表达式参数，程序将会继续执行到下一个断点或异常处。
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_34c1b5c17e959e41baabed05542e04f0_r.png)
**基本用法**：**g [Expression]**
# 2.命令字：gc
**基本功能**：从条件断点恢复执行，其方式与 (单步执行、跟踪或自由执行) 时命中断点的方式相同。 这仅适用于使用“j (条件) ...” 的条件断点的旧样式style 表达式，而不是更简单的“/w”样式条件断点。 有关详细信息，请参阅https://learn.microsoft.com/zh-cn/windows-hardware/drivers/debugger/setting-a-conditional-breakpoint
**基本用法**：**gc**
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_884a8afc8246797d210251e86bdb5f0e_r.png)
# 3.命令字：gh
**基本功能**：用于设置一个新的断点，然后继续执行程序。该断点将会在指定的地址处触发，然后程序会暂停执行并跳转到调试器。
**基本用法**：**gh [Address]**
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_ea7425bf6aef0231dd4a6e5f5272517b_r.png)
# 4.命令字：gn
**基本功能**：用于跳到下一个指令，然后继续执行程序。这对于单步跳过函数调用很有用，即使该函数有多个指令。
**基本用法**：**gn**
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_0ee0d43df5fa29c9bb0ed22a82169651_r.png)
# 5.命令字：gu
**基本功能**：用于执行当前函数并停止在返回调用函数之前。这对于跳过复杂函数的执行非常有用。
**基本用法**：**gu**
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_47185117265a42ffec4ff91bf82e6ad3_r.png)
## 用法描述
这些命令是在调试和分析过程中常用的工具。**g**和**gc**命令用于让程序继续执行，**gh**命令用于设置断点，**gn**命令用于跳到下一个指令，**gu**命令用于执行当前函数并返回到调用函数。通过灵活使用这些命令，可以有效地控制程序的执行过程以便进行调试和分析。