# 2.命令字：aS/as
**基本功能**：定义新别名或重新定义现有别名。
**基本用法**：
**as Name EquivalentLine 
aS Name EquivalentPhrase 
aS Name "EquivalentPhrase" 
as /e Name EnvironmentVariable 
as /ma Name Address 
as /mu Name Address 
as /msa Name Address 
as /msu Name Address 
as /x Name Expression 
aS /f Name File 
as /c Name CommandString**
**参数：**
**Name**
指定别名。 此名称可以是不包含空格或 **ENTER** 击键且不以**“al”、“as”、“aS”**或**“ad”**开头的任何文本字符串。 名称 区分大小写。

**EquivalentLine**
指定等效的别名。 **EquivalentLine** 区分大小写。 必须在 **Name** 和 **EquivalentLine** 之间至少添加一个空格。 这两个参数之间的空格数并不重要。 别名等效项绝不包含前导空格。 在这些空格之后， **EquivalentLine** 包括行的其余部分。 分号、引号和空格被视为文本字符，并包含尾随空格。

**EquivalentPhrase**
指定等效的别名。 **EquivalentPhrase** 区分大小写。 必须在 **Name** 和 **EquivalentPhrase** 之间至少添加一个空格。 这两个参数之间的空格数并不重要。 别名等效项绝不包含前导空格。

可以将 **EquivalentPhrase** 括在引号 (“) 中。 无论是否使用引号， **EquivalentPhrase** 都可以包含空格、逗号和单引号 (') 。 如果将 **EquivalentPhrase** 括在引号中，它可以包含分号，但不能包含其他引号。 如果不将 **EquivalentPhrase** 括在引号中，它可以在除第一个字符以外的任何位置包含引号，但不能包含分号。 无论是否使用引号，都包含尾随空格。

**/e**
设置等效于 **EnvironmentVariable** 指定的环境变量的别名。

**EnvironmentVariable**
指定用于确定别名等效项的环境变量。 使用调试器的环境，而不是目标环境。 如果在命令提示符窗口中启动调试器，则会使用该窗口中的环境变量。

**/ma**
将别名设置为等效于以 **null** 结尾的 **ASCII** 字符串，该字符串以 **Address** 开头。

**/mu**
将别名设置为等效于以 **null** 结尾的 **Unicode** 字符串，该字符串以 **Address** 开头。

**/Msa**
设置与位于 **Address** 处的 **ANSI_STRING** 结构等效的别名。

**/Msu**
将别名设置为等效于位于 **Address** 的 **UNICODE_STRING** 结构。

**Address**
指定用于确定别名等效项的虚拟内存的位置。

**/X**
设置等效于 **Expression** 的 **64** 位值的别名。

**Expression**
指定要计算的表达式。 此值将成为等效的别名。 

**/F**
设置等效于 **File** 文件内容的别名。 应始终将 **/f** 开关与 **aS** 一起使用，而不是与 一起使用。

**File**
指定其内容与别名等效的文件。 文件 可以包含空格，但绝不应将 文件 用引号引起来。 如果指定的文件无效，则会收到“内存不足”错误消息。

**/C**
设置等效于 **CommandString** 指定的命令输出的别名。 别名等效项包括回车符（如果它们存在于命令显示中）以及每个命令显示结束时的回车符 (即使仅指定一个命令) 也是如此。

**CommandString**
指定其输出成为别名等效项的命令。 此字符串可以包含任意数量的命令，这些命令由分号分隔。
## 用法描述
如果不使用任何开关， 则 **as** 命令使用行的其余部分作为等效的别名。

可以使用分号结束 **aS** 命令。 当必须将所有命令放在一行上时，此方法在脚本中非常有用。 请注意，如果分号后面的行部分需要扩展别名，则必须将行的第二部分括在新块中。
## 示例
以下示例生成预期的输出，0x6。
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_5b1c639a88e640fd63261a5424c6bd87_r.png)
如果省略新块，则不会获得预期的输出。 这是因为，在输入新代码块之前，不会扩展新设置的别名。
在以下示例中，省略新块，输出为文本“myAlias”，而不是0x6预期值。
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_2bddf1d574817476be00ef8db2a6a9c5_r.png)

如果使用 **/e**、 **/ma**、 **/mu**、 **/msa**、 **/msu** 或 **/x** 开关， 则 **as** 和 **aS** 命令的工作方式相同，如果遇到分号，命令结束。

如果 **Name** 已是现有别名的名称，则重新定义该别名。

可以使用 **as** 或 **aS** 命令创建或更改任何用户命名的别名。 但不能使用 命令控制固定名称别名 (**$u 0** 到 **$u 9**) 。

可以使用 **/ma**、 **/mu**、 **/msa**、 **/msu**、 **/f** 和 **/c** 开关创建包含回车符的别名。 但是，不能使用包含回车符的别名按顺序执行多个命令。 相反，必须使用分号。