# 命令字：lsf
**基本功能**：用于列举已加载的源文件。
**基本用法**：**lsf [Options]**
**参数：**
     **-func**：仅列举包含已加载函数的源文件。
     **-sort:[+|-]<column>**：按指定列的升序或降序进行排序。可用的列有：**file**（按文件名排序，默认），**fun**（按函数名排序），**lines**(按行数排序）和**hits**（按调用次数排序）。
   示例用法：
     **lsf**：列举所有已加载的源文件信息。
     **lsf -func -sort:lines**：仅列举包含已加载函数的源文件，并按行数排序。

# 命令字：lsc
**基本功能**：用于列举当前源文件的上下文（周围的代码行）。
**基本用法**：**lsc [Options]**
**参数：**
     **-c [<lines>]**：指定要显示的上下文行数，默认为 5 行。
     **-source**：显示源代码行。
     **-line [<line1> [<line2>]]**：指定起始行和结束行。
   示例用法：
     **lsc**：列举当前源文件的默认上下文（5 行）。
     **lsc -c 10 -line 50 100**：列举当前源文件的从第 50 行到第 100 行的上下文（显示 10 行）。
## 示例
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_1bcd9775a1ffb2174a6ca632cbcce293_r.png)

## 用法描述
**"lsf"**命令用于查看已加载的源文件及其文件名、路径和调试信息文件的位置等信息。它可以帮助你了解系统中加载了哪些源文件以及它们的位置。

**"lsc"**命令用于在调试过程中查看当前源文件的上下文，这对于理解代码执行的上下文非常有用。

请注意，为了正确使用**"lsf"**和**"lsc"**命令，你需要确保已正确加载和配置符号文件以及源代码文件。使用"ld"命令加载符号文件，使用**".srcpath"**命令设置源代码搜索路径。