# 命令字：n
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能**：
在gdb中，命令n是普通的单步命令，遇到子函数不进入
在windbg中，命令n用来显示和设置当前所使用的数制（十六进制，十进制等）。
综合以上因素，在ndb中的n行为定义如下：
n后面带有8、10、16三种参数时，表示设置默认的数制，这是遵循windbg老用户的习惯
n后面没有参数或者跟随8、10、16之外的数值时，n用作单步，这是遵循gdb老用户的习惯
**基本用法**：**n [Options]**
**参数：**
**-g**：继续执行程序，直到遇到断点或异常。
**-p**：执行指定的源代码行（对于已加载符号的情况）。
**-v**：执行指定指令的反汇编代码。
**-bc**：清除当前执行点的断点（如果有）。
**-t**：执行跟踪指定的执行点。
**-s**：设置指定执行点为下一个单步执行点（Step Over）。
**-w**：在当前函数的终止处设置断点。
**-bp Address**：设置指定地址处的断点。

示例:
**n**：单步执行，逐条执行程序指令，可用于逐步调试程序。
**n -g**：继续执行程序，直到遇到断点或异常。
**n -p MyFile.cpp:123**：执行源代码中的第 123 行，如果已加载符号文件。
**n -s**：设置当前执行点为下一个单步执行点（Step Over）。
**n -t**：执行跟踪指定的执行点，可用于追踪程序的执行流程。
**n -bp 0x12345678**：在指定地址处设置断点。

## 用法描述
"n"命令允许你控制程序的执行流程，可以逐步执行程序指令、单步跟踪、设置断点等，以进行调试和分析。它对于理解程序的执行路径、查找错误和进行代码分析非常有用。

请注意，在使用"n"命令之前，确保已正确加载符号文件和设置断点（如果需要）。