# 命令字：sx
想了解更多请看https://www.nanocode.cn/#/ndbCmds
**基本功能**：用于设置执行断点。它会在指定的代码行上中断程序的执行。
**基本用法**：**"sx address**
**参数：**
**"sx module !symbol"**：设置在指定模块和符号上的执行断点。示例：**sx myapp!main**.
**"sx address"**：设置在指定地址上的执行断点。示例：**sx 0x0040000**.
**"sx -e"**：列出当前设置的所有执行断点。


# 命令字：sxd
**基本功能**：用于设置数据断点。它会在指定的地址上当数据访问发生时中断程序的执行。
**基本用法**：**"sxd address**
**参数：**
**sxd module !symbol**：设置在指定模块和符号上的数据断点。示例：**sxd myapp!myVariable**.
**sxd address**：设置在指定地址上的数据断点。示例：**sxd 0x00401000**.
**sxd -e**：列出当前设置的所有数据断点。

# 命令字：sxe
**基本功能**：用于设置异常断点。它会在指定的异常类型抛出时中断程序的执行。
**基本用法**：
**sxe exception_code**：设置在指定异常代码上的异常断点。示例：**sxe c0000005** (Access Violation异常).
**sxe module !exception_symbol**：设置在指定模块和异常符号上的异常断点。示例：**sxe kernel32!CreateFileA.**
**sxe -e**：列出当前设置的所有异常断点。


# 命令字：sxi
**基本功能**:用于设置忽略特定异常类型的断点。
**基本用法**：
**sxi exception_code**：设置忽略指定异常代码的断点。示例：**sxi c0000005** (忽略**Access Violation**异常).
**sxi module !exception_symbol**：设置忽略指定模块和异常符号的断点。

# 命令字：sxn
**基本功能**:用于启用或禁用断点。
**基本用法**：
**sxn breakpoint_number**：禁用指定编号的断点。示例：**sxn 1**.
**sxn ***：禁用所有断点。
**sxn breakpoint_number n**：启用指定编号的断点。

# 命令字：sxr
**基本功能**:用于移除已设置的断点。
**基本用法**：
**sxr breakpoint_number**：移除指定编号的断点。示例：**sxr 1.**
**sxr ***：移除所有断点。

## 用法描述
断点在调试过程中非常重要，它们帮助我们在程序的特定位置、数据访问或异常发生时暂停执行，以便我们能够检查程序状态、查看变量的值、跟踪代码执行路径以及调试错误。通过使用这些断点相关命令，我们可以轻松设置、管理和控制断点的行为。