# 软件更新
## NDSrv
### NDSrv介绍
NDSrv用于辅助调试Ubuntu及安卓用户空间，该文件仅在调试用户空间时需要。
### GDK8-Ubuntu
内核版本：4.19.171-yanzi
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/gdkSoftware/ndstub_aarch64
### GDK8-Android
内核版本：4.19.171-yanzi
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/gdkSoftware/ndstub_android
### GDK7
内核版本：5.0.0.23-generic
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/gdkSoftware/ndstub_amd64
## NDSrv更新步骤
```bash
1. 下载源文件
2. 替换原有的ndstub

GDK8-Android：
	adb connect ip
	adb root
	adb shell
	mount -o remount -rw /
	rm -rf /system/bin/ndstub
	Ctrl+C 或 Ctrl+D推出adb命令行
	adb push ndstub /system/bin/
GDK8-Ubuntu：
	sudo rm -rf /opt/ndb/ndsrv
	mv ndstub_aarch64 /opt/ndb/ndstub
GDK7：
	sudo rm -rf /opt/gedu/gdk/ndsrv
	mv ndstub_amd64 /opt/gedu/gdk/ndstub
```
## NDB驱动
https://github.com/geduer/ndb
### NDB驱动介绍
NDB模块用于辅助调试LINUX内核，是一个可动态加载的Linux内核模块（LKM）; 该模块仅在调试Linux内核时需要。
### 最新版本
v1.8: https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Drivers/ndb_v18.tgz
### 历史版本
v1.7: https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Drivers/ndb_v17.tar
v1.6：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Drivers/ndb_v16.tar.gz
v1.3：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Drivers/ndb_v13.tgz
v1.2：https://gedu.oss-cn-beijing.aliyuncs.com/GDK8_Drivers/ndb_v12.tgz
## NDB驱动更新步骤
```bash
1. 下载源代码压缩包
2. 解压文件
tar -xvf ndb.tar.gz
3. 进入目录
cd ndb
4. 编译驱动
make clean && make
5. 卸载原驱动（如果存在）
sudo rmmod ndb
6. 安装新驱动
sudo ./install.sh
```
## 英特尔DCI驱动和Open IPC软件
DCI驱动和OpenIPC软件用于支持英特尔的DCI调试技术，包含在英特尔的多个软件包中， 比如Intel System Debugger（ISD），Intel oneAPI开发套件等。
考虑到ISD等软件包的体量巨大，很多用户在安装时遇到问题，所以我们选取了其中部分模块，以方便GDK7用户。这些软件的版权归英特尔公司所有。
下载链接：https://gedu.oss-cn-beijing.aliyuncs.com/DCI/DCI.zip
## WinDBG调试引擎
WinDBG调试是微软公司WinDBG软件的一部分，这里选取的只是其中的几个DLL文件; 该资源仅供个别用户解决软件兼容性问题时使用。
下载链接：https://www.nanocode.cn/software/gdk7/ms_dbgeng.zip